"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongodb = require("mongodb");
function MongoDb(alias = 'localhost:27017') {
    let db;
    return {
        start({ config, endpoints }, _, stop) {
            return __awaiter(this, void 0, void 0, function* () {
                const address = endpoints.getServiceAddress(alias);
                const authUri = config.user && config.password ? `${config.user}:${config.password}@` : '';
                const url = `mongodb://${authUri}${address}/${config.db}`;
                db = yield mongodb.MongoClient.connect(url, config.options);
                db.on('error', stop);
                return db;
            });
        },
        stop() {
            return __awaiter(this, void 0, void 0, function* () {
                if (db)
                    db.close();
            });
        }
    };
}
exports.MongoDb = MongoDb;
exports.default = MongoDb;
